#include <d3dx8.h>
#include <stdio.h>
#include "Labyrinth.h"

#define TAG_LEN 	256				// ECTiBINjt@C̃^O̍ő啶
#define MAP_WDH		(WDH-1)/2		// n}̉
#define MAP_HGT		(HGT-1)/2		// n}̍
#define P_NUM		15				// ʘHbV̐
#define P_SIZE		0.6f			// ʘHbV̈ӂ̒
#define M_V			0.05f			// ړx
#define L_D			0.05f			// _ƒ_̋
#define PI			(float)3.1415926535897932
#define RELEASE(p)	if (p){p->Release();p=NULL;}

struct LVERTEX
{
	D3DXVECTOR3	v;				// W
	D3DXVECTOR3	n;				// @xNg
	float		tu,tv;			// eNX`W
};
#define FVF_LVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)

typedef struct{
	D3DXVECTOR2	t[2][4];			// _̃eNX`W
	int 		vtx_ct[P_NUM+1];	// e_
	int 		face_ct[P_NUM+1];	// eʐ
}PASS,*LPPASS;

LPDIRECT3D8 			g_pD3D = NULL;		// Direct3DIuWFNg
LPDIRECT3DDEVICE8		g_pD3DDev = NULL;	// foCXIuWFNg
D3DPRESENT_PARAMETERS   g_d3dpp;			// obNobt@̃p[^
LPDIRECT3DTEXTURE8		g_pTex[2] = {NULL,NULL};
LPDIRECT3DVERTEXBUFFER8	g_pVB1 = NULL;		// o[ebNX obt@

UINT        g_Width,g_Height;		// ʂ̃TCY
D3DFORMAT   g_Format;				// ʂ̃tH[}bg
PASS		g_p2;					// ʘH̃bVf[^
float		g_look_x = 0.0f;		// _ X W
float		g_look_y = 0.0f;		// _ Y W
float		g_look_z = 0.0f;		// _ Z W
float		g_pos_x;				// _XW
float		g_pos_z;				// _ZW
float		g_roll = 180;			// _̉]px (x)
D3DXVECTOR3	g_Dir;					// _̉]px (xNg)
int			g_flagDir;				// ݂̉]i:0, :1, :2, k:3j
int 		g_map1[MAP_HGT][MAP_WDH];// n}f[^i[
bool 		g_map2[MAP_HGT][MAP_WDH];// isoHi[
bool 		g_map3[MAP_HGT][MAP_WDH];// isoHi[ipj
bool		g_map4[MAP_HGT][MAP_WDH];// `tOi`悷:1, `悵Ȃ:0j
bool		g_wall[P_NUM][4] = {{0,0,0,1},{0,0,1,0},{0,1,0,0},{1,0,0,0},
								{1,0,0,1},{0,0,1,1},{0,1,1,0},{1,1,0,0},
								{1,0,1,1},{0,1,1,1},{1,1,1,0},{1,1,0,1},
								{1,0,1,0},{0,1,0,1},{0,0,0,0} };	// eʘH̕ǂ̃tO
int			g_Tuv[P_NUM] = { 1, 1, 1, 1, 2, 2, 2, 2,
							-1,-1,-1,-1,-1,-1, 0 };	// 0.1{̏ktO

HRESULT InitD3D(HWND hWnd);
bool	InitGeometry();
void	Set_Light();
void	Set_Material();
void	Set_ViewMatrix();
void	Draw_Main();
void	Draw_Passage();
void	Visible_Passage();
bool	Visible_Passage_Sub (int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub1(int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub2(int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub3(int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub4(int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub5(int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub6(int nx, int nz, int flagDir, int range);
void	Go();
void	Create_Map();
bool	Set_VB(LPDIRECT3DVERTEXBUFFER8 *ppVB, D3DXVECTOR3 *pv, D3DXVECTOR3 *pn, int (*pf)[4], int t_face_ct);
bool	Load_EctFile_Bin(void *pMem, int size);
bool	Load_EctFile(void *pMem);
void	Term();

// Direct3D ̏
HRESULT InitD3D(HWND hWnd)
{
	HRESULT 		hr = E_FAIL;
	D3DDISPLAYMODE	d3ddisp;
	bool			flag_Adapter = false;
	int				i;
	
	// Direct3D8 IuWFNg쐬
	g_pD3D = Direct3DCreate8(D3D_SDK_VERSION);
	if (!g_pD3D)
		return hr;
	
	// ݂̉ʃ[h()̎擾
	hr = g_pD3D->GetAdapterDisplayMode(0, &d3ddisp);
	if FAILED(hr) {
		return hr;
	}
	
	g_Width  = d3ddisp.Width;    // ݂̉ʂ̕
	g_Height = d3ddisp.Height;   // ݂̉ʂ̍
	
	// ftHg̃A_v^ŗp\ȉʃ[h̐擾
	int mode_num = g_pD3D->GetAdapterModeCount(0);
	
	for(i=0;i<mode_num;i++){
		// ftHg̃A_v^ŗp\ȉʃ[h()擾
		D3DDISPLAYMODE	dispMode;
		g_pD3D->EnumAdapterModes(0, i, &dispMode);
		
		// ݂̉ʃ[hp\H
		if(dispMode.Width  == d3ddisp.Width  &&
		   dispMode.Height == d3ddisp.Height &&
		   dispMode.Format == d3ddisp.Format)
		{
			g_Format = d3ddisp.Format;
			flag_Adapter = true;
			break;
		}
	}
	
	if(!flag_Adapter){	 // ݂̉ʃ[hΉĂȂƂ
		return hr;
	}
	
	// foCX̃p[^Lq
	ZeroMemory(&g_d3dpp, sizeof(g_d3dpp));
	g_d3dpp.Windowed = TRUE;					// TRUE:Window\@FALSE:Sʕ\
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;
	g_d3dpp.BackBufferWidth  = g_Width;			// obNobt@̕
	g_d3dpp.BackBufferHeight = g_Height;		// obNobt@̍
	g_d3dpp.BackBufferFormat = g_Format;		// obNobt@̃tH[}bg
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;// Z obt@̃tH[}bg
	
	// foCX̍쐬
	 hr = g_pD3D->CreateDevice(
								  0,
								  D3DDEVTYPE_HAL,
								  hWnd,
								  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
								  &g_d3dpp,
								  &g_pD3DDev
							  );
	
	if FAILED(hr) {
		return hr;
	}
	
	// ݒ
	if(!InitGeometry()){
		return E_FAIL;
	}
	
	return S_OK;
}// InitD3D

// ݒ
bool InitGeometry()
{
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE,  TRUE);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	g_pD3DDev->SetVertexShader(FVF_LVERTEX);
	
	// vWFNVs
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,60.0f * PI / 180.0f,(float)g_Width/g_Height,0.01f,4.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
	
	// n}f[^̓ǂݍ
	Create_Map();
	
	// eNX`̓ǂݍ
	HRSRC   hFound;
	HGLOBAL hRes;
	LPVOID	pMem;
	int		PicID[2] = {IDR_JPEG1, IDR_JPEG2};
	for(int i=0;i<2;i++){
		hFound = FindResource(NULL,MAKEINTRESOURCE(PicID[i]),"jpeg");
		hRes   = LoadResource(NULL,hFound);
		pMem   = LockResource(hRes);
		D3DXCreateTextureFromFileInMemoryEx(g_pD3DDev,pMem,SizeofResource(NULL,hFound),0,0,0,0,g_Format,D3DPOOL_MANAGED,D3DX_FILTER_LINEAR,D3DX_FILTER_LINEAR,0xff000000,NULL,NULL,&g_pTex[i]);
	}
	
	// eNX`W
	for(i=0;i<2;i++){
		g_p2.t[i][0] = D3DXVECTOR2(0,0);
		g_p2.t[i][1] = D3DXVECTOR2(1,0);
		g_p2.t[i][2] = D3DXVECTOR2(1,1);
		g_p2.t[i][3] = D3DXVECTOR2(0,1);
	}
	g_p2.t[1][1] = D3DXVECTOR2(0.1f,0);
	g_p2.t[1][2] = D3DXVECTOR2(0.1f,1);
	
	// \[Xf[^ǂݍ
	hFound = FindResource(NULL,MAKEINTRESOURCE(IDR_TEXT1),"text");
	hRes   = LoadResource(NULL,hFound);
	pMem   = LockResource(hRes);
	if(pMem == NULL){
		return 0;
	}
	int size = SizeofResource(NULL, hFound);
	// ʘHbV̓ǂݍ
	if(!Load_EctFile_Bin(pMem, size)){
		if(!Load_EctFile(pMem)){
			return 0;
		}
	}
	
	// _̏ʒu
	g_pos_x = 0.3f;
	g_pos_z = MAP_HGT * P_SIZE - 0.3f;

	return 1;
}// InitGeometry

// Ɩ̐ݒ
void Set_Light()
{
	D3DLIGHT8	light;
	
	ZeroMemory(&light, sizeof(D3DLIGHT8));
	light.Type		= D3DLIGHT_SPOT;							// Cg̎ށiX|bgCgj
	light.Position	= D3DXVECTOR3(g_look_x,g_look_y,g_look_z);	// Cg̈ʒu
	light.Direction = D3DXVECTOR3(g_Dir.x,0,g_Dir.z);			// Cǧ
	light.Range 	= 3.0f;										// Cg̓͂
	light.Theta		= 1.0f;										// OR[̊px
	light.Phi		= 4.0f;										// R[̊px
	light.Falloff	= 1.0f;										// OR[Ԃ̌W
	light.Attenuation2 = 3.0f;									// ɂ錸W
	light.Ambient.r = light.Diffuse.r = 1.0f;
	light.Ambient.g = light.Diffuse.g = 1.0f;
	light.Ambient.b = light.Diffuse.b = 1.0f;
	g_pD3DDev->SetLight(0, &light);
}// Set_Light

// }eA̐ݒ
void Set_Material()
{
	D3DMATERIAL8 mtrl;
	
	ZeroMemory(&mtrl, sizeof(D3DMATERIAL8));
	mtrl.Diffuse.a = mtrl.Ambient.a = 1.0f;
	mtrl.Diffuse.r = mtrl.Ambient.r = 0.8f;
	mtrl.Diffuse.g = mtrl.Ambient.g = 0.8f;
	mtrl.Diffuse.b = mtrl.Ambient.b = 0.8f;
	// }eAKp
	g_pD3DDev->SetMaterial(&mtrl);
}// Set_Material

// r[s̐ݒ
void Set_ViewMatrix()
{
	float		target_x,target_y,target_z;
	D3DXMATRIX	matView;
	g_look_x = -g_Dir.x * L_D + g_pos_x;
	g_look_y = 0.3f;
	g_look_z = -g_Dir.z * L_D + g_pos_z;
	target_x   = g_pos_x;
	target_y   = 0.3f;
	target_z   = g_pos_z;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(g_look_x,g_look_y,g_look_z),&D3DXVECTOR3(target_x,target_y,target_z),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
}// Set_ViewMatrix

// `
void Draw_Main()
{
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	g_pD3DDev->BeginScene();
	
	g_Dir.x = (float)sin(g_roll/180*PI);
	g_Dir.z = (float)cos(g_roll/180*PI);
	
	Set_ViewMatrix();	// r[s̐ݒ
	
	Go();				// ړƉ]
	
	Set_Light();		// Cg̐ݒ
	Set_Material();
	
	Draw_Passage();		// ʘH̕`
	
	g_pD3DDev->EndScene();
	g_pD3DDev->SetTexture(0, NULL);
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// ʘH̕`
void Draw_Passage()
{
	int 			i,k,m,n;
	LVERTEX			lv[4];
	
	Visible_Passage();	// ʘH̉
	
	g_pD3DDev->SetStreamSource(0, g_pVB1, sizeof(LVERTEX));
	
	for(n=0;n<MAP_HGT;n++){
		for(m=0;m<MAP_WDH;m++){
			if(!g_map4[n][m]){
				continue;
			}
			D3DXMATRIX	matT;
			D3DXMatrixTranslation(&matT, m*P_SIZE, 0, (MAP_HGT-1-n)*P_SIZE);
			g_pD3DDev->SetTransform(D3DTS_WORLD, &matT);
			k = g_map1[n][m] - 1;
			for(i=g_p2.face_ct[k];i<g_p2.face_ct[k+1];i++){
				if(i == (g_p2.face_ct[k+1]-1)){
					g_pD3DDev->SetTexture(0, g_pTex[1]);
				}
				else{
					g_pD3DDev->SetTexture(0, g_pTex[0]);
				}
				g_pD3DDev->DrawPrimitive(D3DPT_TRIANGLEFAN,i*4,2);
			}
		}
	}
}// Draw_Passage

// ʘH̉
void Visible_Passage()
{
	int			nx,nz;					// ݂n}̈ʒu
	static int	nx_pre = 0,nz_pre = 0;	// O񂢂n}̈ʒu
	static int	flagDir_pre = -1;		// Ỏ]
	int			dx[4] = {-1, 0, 1, 0};	// eis̈ړl
	int			dz[4] = { 0, 1, 0,-1};	// eis̈ړl

	
	nx = (int)(g_pos_x / P_SIZE);
	nz = MAP_HGT - (int)(g_pos_z / P_SIZE) - 1;
	if(g_roll >= 225 && g_roll < 315){
		g_flagDir = 0;
	}
	else if(g_roll >= 135 && g_roll < 225){
		g_flagDir = 1;
	}
	else if(g_roll >= 45 && g_roll < 135){
		g_flagDir = 2;
	}
	else{
		g_flagDir = 3;
	}
	
	if(nx == nx_pre && nz == nz_pre && g_flagDir == flagDir_pre){
		return;
	}
	
	// tȌ
	for(int z=0;z<MAP_HGT;z++){
		for(int x=0;x<MAP_WDH;x++){
			g_map4[z][x] = 0;
		}
	}
	
	// ݒn̑O̒ʘHU܂˂܂ŃtOPɂ
	int nx2,nz2;
	nx2 = nx;
	nz2 = nz;
	while(Visible_Passage_Sub6(nx2, nz2, g_flagDir, 5)){
		nx2 += dx[g_flagDir];
		nz2 += dz[g_flagDir];
	}
	
	nx_pre      = nx;
	nz_pre      = nz;
	flagDir_pre = g_flagDir;
}// Visible_Passage

// flagDir̓˂܂ł̒ʘHtOPɂB
bool Visible_Passage_Sub (int nx, int nz, int flagDir, int range)
{
	static int ct = 0;
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	g_map4[nz][nx] = 1;
	ct ++;
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	return 1;
}// Visible_Passage_Sub

// flagDir̂P܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub1(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub (nx2, nz2, 1, 2)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub (nx2, nz2, 3, 2)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub (nx2, nz2, 0, 2)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub (nx2, nz2, 2, 2)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub1

// flagDir̂Q܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub2(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub1(nx2, nz2, 1, 2)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub1(nx2, nz2, 3, 2)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub1(nx2, nz2, 0, 2)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub1(nx2, nz2, 2, 2)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub2

// flagDir̂R܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub3(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub2(nx2, nz2, 1, 2)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub2(nx2, nz2, 3, 2)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub2(nx2, nz2, 0, 2)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub2(nx2, nz2, 2, 2)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub3

// flagDir̂S܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub4(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub3(nx2, nz2, 1, 3)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub3(nx2, nz2, 3, 3)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub3(nx2, nz2, 0, 3)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub3(nx2, nz2, 2, 3)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub4

// flagDir̂T܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub5(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub4(nx2, nz2, 1, 3)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub4(nx2, nz2, 3, 3)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub4(nx2, nz2, 0, 3)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub4(nx2, nz2, 2, 3)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub5

// flagDir̂U܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub6(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub5(nx2, nz2, 1, 4)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub5(nx2, nz2, 3, 4)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub5(nx2, nz2, 0, 4)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub5(nx2, nz2, 2, 4)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub6

// ړƉ]
void Go()
{
	int		nx,nz;
	float	go_roll;
	nx = (int)(g_pos_x / P_SIZE);
	nz = (int)((MAP_HGT * P_SIZE - g_pos_z) / P_SIZE);
	
	if(g_map2[nz][nx]){
		g_map2[nz][nx] = 0;
	}
	
	if(nx != 0 && g_map2[nz][nx-1] && Map[nz*2+1][nx*2+1-1] != 1){
		go_roll = 270;
	}
	else if(nx != MAP_WDH-1 && g_map2[nz][nx+1] && Map[nz*2+1][nx*2+1+1] != 1){
		go_roll = 90;
	}
	else if(nz != 0 && g_map2[nz-1][nx] && Map[nz*2+1-1][nx*2+1] != 1){
		go_roll = 0;
	}
	else if(nz != MAP_HGT-1 && g_map2[nz+1][nx] && Map[nz*2+1+1][nx*2+1] != 1){
		go_roll = 180;
	}
	else{	// I
		memcpy(g_map2, g_map3, sizeof(g_map3));	// isoH̏
		return;
	}
	
	if(go_roll == 0 && g_roll >= 270){
		g_roll += 3;
		if(g_roll >= 360)
			g_roll -= 360;
		if((nx != 0 && nz != MAP_HGT-1) || (nx != MAP_WDH-1 && nz != 0)){
			g_pos_x += 0.014f * (float)sin(g_roll/180*PI);
			g_pos_z += 0.014f * (float)cos(g_roll/180*PI);
		}
	}
	else if(go_roll == 270 && g_roll < 90){
		g_roll -= 3;
		if(g_roll < 0)
			g_roll += 360;
		if((nx != 0 && nz != MAP_HGT-1) || (nx != MAP_WDH-1 && nz != 0)){
			g_pos_x += 0.014f * (float)sin(g_roll/180*PI);
			g_pos_z += 0.014f * (float)cos(g_roll/180*PI);
		}
	}
	else if(go_roll-g_roll > 0){
		g_roll += 3;
		if(g_roll >= 360)
			g_roll -= 360;
		if((nx != 0 && nz != MAP_HGT-1) || (nx != MAP_WDH-1 && nz != 0)){
			g_pos_x += 0.014f * (float)sin(g_roll/180*PI);
			g_pos_z += 0.014f * (float)cos(g_roll/180*PI);
		}
	}
	else if(go_roll-g_roll < 0){
		g_roll -= 3;
		if(g_roll < 0)
			g_roll += 360;
		if((nx != 0 && nz != MAP_HGT-1) || (nx != MAP_WDH-1 && nz != 0)){
			g_pos_x += 0.014f * (float)sin(g_roll/180*PI);
			g_pos_z += 0.014f * (float)cos(g_roll/180*PI);
		}
	}
	else{
		g_pos_x += 0.03f * (float)sin(g_roll/180*PI);
		g_pos_z += 0.03f * (float)cos(g_roll/180*PI);
	}
}// Go

// n}̍쐬
void Create_Map()
{
	int		k,x,z;
	bool	map2[HGT][WDH],map4[MAP_HGT][MAP_WDH];
	int		map3[MAP_HGT][MAP_WDH];
	
	// H̎
	Labyrinth();
	
	// 2  0 ɂ
	for(z=0;z<HGT;z++){
		for(x=0;x<WDH;x++){
			if(Map[z][x] == 1){
				map2[z][x] = 1;
			}
			else{
				map2[z][x] = 0;
			}
		}
	}
	
	// n}̍쐬
	for(z=1;z<HGT;z+=2){
		for(x=1;x<WDH;x+=2){
			g_map1[x/2][z/2] = 0;
			for(k=0;k<P_NUM;k++){
				if( map2[z][x-1] == g_wall[k][0] && map2[z][x+1] == g_wall[k][2] && 
					map2[z-1][x] == g_wall[k][3] && map2[z+1][x] == g_wall[k][1]){
					map3[z/2][x/2] = k+1;
					break;
				}
			}
		}
	}
	for(z=0;z<MAP_HGT;z++){
		for(x=0;x<MAP_WDH;x++){
			g_map1[z][x] = map3[z][x];
		}
	}
	
	// isoH̍쐬
	for(z=1;z<HGT;z+=2){
		for(x=1;x<WDH;x+=2){
			if(Map[z][x] == 2){
				map4[z/2][x/2] = 1;
			}
			else{
				map4[z/2][x/2] = 0;
			}
		}
	}
	for(z=0;z<MAP_HGT;z++){
		for(x=0;x<MAP_WDH;x++){
			g_map2[z][x] = g_map3[z][x] = map4[z][x];
		}
	}
}// Create_Map

// _obt@̍쐬
bool Set_VB(LPDIRECT3DVERTEXBUFFER8 *ppVB, D3DXVECTOR3 *pv, D3DXVECTOR3 *pn, int (*pf)[4], int t_face_ct)
{
	int	i,j,k,idx;
	int sizeVB = (t_face_ct * 4) * sizeof(LVERTEX);
	if(FAILED(g_pD3DDev->CreateVertexBuffer(sizeVB, 0, FVF_LVERTEX, D3DPOOL_DEFAULT, ppVB)))
		return 0;
	BYTE *pVtx;
	if(FAILED((*ppVB)->Lock(0, sizeVB, &pVtx, 0)))
		return 0;
	int offset = 0;
	for(k=0;k<P_NUM;k++){
		for(i=g_p2.face_ct[k];i<g_p2.face_ct[k+1];i++){
			for(j=0;j<4;j++){
				idx = g_p2.vtx_ct[k] + pf[i][j];
				memcpy(pVtx+offset, &pv[idx], sizeof(pv[idx]));
				offset += sizeof(pv[idx]);
				memcpy(pVtx+offset, &pn[idx], sizeof(pn[idx]));
				offset += sizeof(pn[idx]);
				if(g_Tuv[k] != -1 && i >= g_Tuv[k]+g_p2.face_ct[k] && i < g_p2.face_ct[k+1]-2){
					// XW 0.1{
					memcpy(pVtx+offset, &g_p2.t[1][j].x, sizeof(float));
					offset += sizeof(float);
					memcpy(pVtx+offset, &g_p2.t[1][j].y, sizeof(float));
					offset += sizeof(float);
				}
				else{
					// 1.0{
					memcpy(pVtx+offset, &g_p2.t[0][j].x, sizeof(float));
					offset += sizeof(float);
					memcpy(pVtx+offset, &g_p2.t[0][j].y, sizeof(float));
					offset += sizeof(float);
				}
			}
		}
	}
	(*ppVB)->Unlock();
	return 1;
}// Set_VB

// ʘHbV̓ǂݍ݁ioCi`j
bool Load_EctFile_Bin(void *pMem, int size)
{
	int			ct = 0,p_ct = 0;
	UINT		len_tag,size_data;
	int			i,k;
	D3DXVECTOR3	v[P_NUM*32];	// _̍W
	D3DXVECTOR3	n[P_NUM*32];	// _̖@xNg
	int			f[P_NUM*10][4];	// eʂ̒_ԍ
	char		tag[TAG_LEN];
	char		tag_list[][TAG_LEN] = {"parts_count","vertex_count","face_count","vertices","normals","faces"};

	if(pMem == NULL){
		return 0;
	}
	
	ct += (sizeof(char)*4+sizeof(int));	// ǂݔ΂
	while(ct < size){
		memcpy(&len_tag, (BYTE*)pMem+ct, sizeof(int));
		ct += sizeof(int);
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		memcpy(tag, (BYTE*)pMem+ct, sizeof(char)*len_tag);
		ct += sizeof(char)*len_tag;
		memcpy(&size_data, (BYTE*)pMem+ct, sizeof(int));
		ct += sizeof(int);
		bool flag = false;
		for(k=0;k<sizeof(tag_list)/sizeof(tag_list[0]);k++){
			if(!strcmp(tag, tag_list[k])){
				flag = true;
switch(k)
{
case 0:
	memcpy(&p_ct, (BYTE*)pMem+ct, sizeof(int));
	ct += sizeof(int);
	if(p_ct != P_NUM){
		return 0;
	}
	break;
case 1:
	g_p2.vtx_ct[0] = 0;
	for(i=0;i<p_ct;i++){
		memcpy(&g_p2.vtx_ct[i+1], (BYTE*)pMem+ct, sizeof(int));
		g_p2.vtx_ct[i+1] += g_p2.vtx_ct[i];
		ct += sizeof(int);
	}
	break;
case 2:
	g_p2.face_ct[0] = 0;
	for(i=0;i<p_ct;i++){
		memcpy(&g_p2.face_ct[i+1], (BYTE*)pMem+ct, sizeof(int));
		g_p2.face_ct[i+1] += g_p2.face_ct[i];
		ct += sizeof(int);
	}
	break;
case 3:
	memcpy(v, (BYTE*)pMem+ct, sizeof(D3DXVECTOR3)*g_p2.vtx_ct[p_ct]);
		ct += sizeof(D3DXVECTOR3)*g_p2.vtx_ct[p_ct];
	break;
case 4:
	memcpy(n, (BYTE*)pMem+ct, sizeof(D3DXVECTOR3)*g_p2.vtx_ct[p_ct]);
	ct += sizeof(D3DXVECTOR3)*g_p2.vtx_ct[p_ct];
	break;
case 5:
	memcpy(f, (BYTE*)pMem+ct, sizeof(int[4])*g_p2.face_ct[p_ct]);
	ct += sizeof(int[4])*g_p2.face_ct[p_ct];
	break;
}
				break;
			}
		}
		if(!flag){
			ct += size_data;			// ǂݔ΂
		}
	}
	
	if(!p_ct){
		return 0;
	}
	
	// _obt@̍쐬
	Set_VB(&g_pVB1, v, n, f, g_p2.face_ct[p_ct]);
	
	return 1;
}// Load_EctFile_Bin

// ʘHbV̓ǂݍ݁ieLXg`j
bool Load_EctFile(void *pMem)
{
	FILE		*file1;
	char	 	ss[256],*p = NULL;
	float 		ww[8];
	int			flag = 0;
	int 		vv[4],p_ct = 0,ct1 = 0,ct2 = 0;
	D3DXVECTOR3	v[P_NUM*32];	// _̍W
	D3DXVECTOR3	n[P_NUM*32];	// _̖@xNg
	int			f[P_NUM*10][4];	// eʂ̒_ԍ
	
	g_p2.vtx_ct[0] = 0;
	g_p2.face_ct[0] = 0;
	
	if(pMem == NULL){
		return 0;
	}
	// e| t@Cɏ
	if((file1 = tmpfile()) == NULL){
		return 0;
	}
	fputs((char*)pMem,file1);
	// t@C|C^擪ɖ߂
	rewind(file1);
	// e| t@Cǂݍ
	while(!feof(file1)){
		
		fgets(ss,256,file1);
		p = strstr(ss,"\r\n");
		if(p){
			strcpy(p,"");
		}
		
		// p[cƂ̒_WƖ@xNg
		if(!strcmp(ss,"<vertices>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</vertices>")){
			flag = 0;
			g_p2.vtx_ct[p_ct+1] = ct1;
		}
		else if(flag == 1){
			sscanf(ss,"%f %f %f %f %f %f %f %f",&ww[0],&ww[1],&ww[2],&ww[3],&ww[4],&ww[5],&ww[6],&ww[7]);
			v[ct1].x = ww[0];
			v[ct1].y = ww[1];
			v[ct1].z = ww[2];
			n[ct1].x = ww[3];
			n[ct1].y = ww[4];
			n[ct1].z = ww[5];
			ct1 ++;
		}
		
		// p[cƂ̖ʂ\钸_W̔ԍ
		else if(!strcmp(ss,"<faces>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</faces>")){
			flag = 0;
			g_p2.face_ct[p_ct+1] = ct2;
		}
		else if(flag == 2){
			sscanf(ss,"%d %d %d %d",&vv[0],&vv[1],&vv[2],&vv[3]);
			f[ct2][0] = vv[0];
			f[ct2][1] = vv[1];
			f[ct2][2] = vv[2];
			f[ct2][3] = vv[3];
			ct2 ++;
		}
		
		// ǂݍ񂾃p[c̐
		else if(!strcmp(ss,"</polygon_mesh>")){
			p_ct ++;
		}
	}
	
	fclose(file1);
	
	_rmtmp();
	
	// _obt@̍쐬
	Set_VB(&g_pVB1, v, n, f, g_p2.face_ct[p_ct]);
	
	return 1;
}// Load_EctFile

// I
void Term()
{
	RELEASE(g_pTex[0]);
	RELEASE(g_pTex[1]);
	RELEASE(g_pVB1);
	RELEASE(g_pD3DDev);
	RELEASE(g_pD3D);
}// Term
